geos::operation::buffer::BufferSubgraph Class Reference

A connected subset of the graph of DirectedEdge and geomgraph::Node. More...

`#include <BufferSubgraph.h>`

## Public Member Functions

std::vector< geomgraph::DirectedEdge * > * | getDirectedEdges ()
std::vector< geomgraph::Node * > * | getNodes ()
geom::Coordinate * | getRightmostCoordinate ()
| Gets the rightmost coordinate in the edges of the subgraph.
void | create (geomgraph::Node *node)
| Creates the subgraph consisting of all edges reachable from this node.
void | computeDepth (int outsideDepth)
void | findResultEdges ()
| Find all edges whose depths indicates that they are in the result area(s).
int | compareTo (BufferSubgraph *)
| BufferSubgraphs are compared on the x-value of their rightmost Coordinate.
geom::Envelope * | getEnvelope ()
| Computes the envelope of the edges in the subgraph. The envelope is cached after being computed.

## Friends

std::ostream & | operator<< (std::ostream &os, const BufferSubgraph &bs)

## Detailed Description

A connected subset of the graph of DirectedEdge and geomgraph::Node.

Its edges will generate either

- a single polygon in the complete buffer, with zero or more holes, or
- ne or more connected holes

## Member Function Documentation

## compareTo()

int geos::operation::buffer::BufferSubgraph::compareTo | ( | BufferSubgraph * |  | ) |

BufferSubgraphs are compared on the x-value of their rightmost Coordinate.

This defines a partial ordering on the graphs such that:

g1 >= g2 <==> Ring(g2) does not contain Ring(g1)

where Polygon(g) is the buffer polygon that is built from g.

This relationship is used to sort the BufferSubgraphs so that shells are guaranteed to be built before holes.

## create()

void geos::operation::buffer::BufferSubgraph::create | ( | geomgraph::Node * | node | ) |

Creates the subgraph consisting of all edges reachable from this node.

Finds the edges in the graph and the rightmost coordinate.

Parameters

  node | a node to start the graph traversal from

## findResultEdges()

void geos::operation::buffer::BufferSubgraph::findResultEdges | ( |  | ) |

Find all edges whose depths indicates that they are in the result area(s).

Since we want polygon shells to be oriented CW, choose dirEdges with the interior of the result on the RHS. Mark them as being in the result. Interior Area edges are the result of dimensional collapses. They do not form part of the result area boundary.

## getEnvelope()

geom::Envelope * geos::operation::buffer::BufferSubgraph::getEnvelope | ( |  | ) |

Computes the envelope of the edges in the subgraph. The envelope is cached after being computed.

Returns
  the envelope of the graph.

The documentation for this class was generated from the following file:

- BufferSubgraph.h